/**
  AutoPlay - Unobtrusive Automatic Video player for PmWiki
  Written by (c) Petko Yotov 2014    www.pmwiki.org/Petko

  This text is written for PmWiki; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version. See pmwiki.php for full details
  and lack of warranty.

  Version 20140408
*/

function APgrab(tag, cn, par) {
  par = par || document;
  var i, r = [], rx = new RegExp('\\b'+cn+'\\b'), x = par.getElementsByTagName(tag);
  for(i=0;i<x.length; i++) if( (!cn) || rx.test(x[i].className)) r.push(x[i]);
  return r;
}

var AutoPlay = function() {
  var a, W, H, player, stl, i, j, k, links, href, src, d, scripts, players = [], AutoPlayDir, allspans, idcnt = 0, rx, lnk, iheight= '315px', iwidth='560px', tn;
  scripts = APgrab('script');
  for(i=0; i<scripts.length; i++) {
    a = scripts[i].src.match(/^(.*)autoplay\.js$/);
    if(! a) continue;
    AutoPlayDir = a[1];
    break;
  }

  players = players.concat(APgrab('span', '(player|map)'), APgrab('dl', 'map'));

  rx = [ // more will be added in the future
    [/^http:\/\/vimeo\.com\/(\d+)$/i, 'http://player.vimeo.com/video/$1?title=0&byline=0&portrait=0&autoplay=0'],
    [/^http:\/\/www\.youtube\.com\/watch\?v=([^&]+)(&.*)?$/i, 'http://www.youtube.com/embed/$1'],
    [/^http:\/\/youtu\.be\/([^&?]+)([&?].*)?$/i, 'http://www.youtube.com/embed/$1'],
    [/^https?:\/\/[a-z-]+\.facebook\.com\/photo\.php\?v=(\d+)$/i, 'http://www.facebook.com/video/embed?video_id=$1'],
    [/^http.*openstreetmap\.org.*#map=[^\s]+$/i, AutoPlayDir+'/osmap.html#']
  ];

  for (i=0; i<players.length; i++) {
    player = players[i];
    tn = player.tagName.toLowerCase();
    stl = player.getAttribute('style');
    if(stl != null && typeof stl == 'object') { // MSIE<8
      stl="width:"+player.style.width+';'+" height:"+player.style.height+';'
    }
    if(stl) {
      a = stl.match(/width: *([0-9\.]+ *(%|p[xtc]|e[mx]|[mc]?m))/i)
      W = (a) ? a[1] : ((player.className.indexOf('map')<0)? iwidth : '100%');
      a = stl.match(/height: *([\d.]+ *(%|p[xtc]|e[mx]|[mc]?m))/i)
      H = (a) ? a[1] : iheight;
    }
    else {
      W = (player.className.indexOf('map')<0)? iwidth : '100%';
      H = iheight;
    }

    if(tn=='span') {
      links = APgrab('a', false, player);
      if(! links) continue;

      for (j=0; j<links.length; j++) {
        lnk = links[j];
        href = lnk.href;
        for(k=0; k<rx.length; k++) {
          if(! href.match(rx[k][0])) continue;

          src = href.replace(rx[k][0], rx[k][1]);
          if(src.match(/#$/)) {
            if(!lnk.id) lnk.id = 'auto_play_id_'+(idcnt++);
            src += lnk.id;
          }
          APFrame(lnk, src, W, H);
          break;
        }
      }
    }
    else if(tn=='dl') {
      if(!player.id) player.id = 'auto_play_id_'+(idcnt++);
      APFrame(player, AutoPlayDir+'/osmap.html#'+player.id, W, H);
    }
  }
}

function APFrame(elm, src, W, H) {
  var d = document.createElement("iframe");
  d.frameborder=0;
  d.marginheight=0;
  d.marginwidth=0;
  d.allowfullscreen = true;
  d.src=src;
  d.setAttribute('style', "border: 1px solid black; display: block; width: "+W+"; height: "+H+";");
  if(elm.id) d.id = 'iframe_'+elm.id;

  elm.parentNode.insertBefore(d, elm);
  elm.style.display = 'none';
}

setTimeout("AutoPlay()", 50);
